@ngGmapModule "directives.api.models.child", ->
    class @WindowChildModel extends oo.BaseObject
        @include directives.api.utils.GmapUtil
        constructor: (scope, opts, isIconVisibleOnClick, mapCtrl, markerCtrl, $http, $templateCache, $compile,@element, needToManualDestroy = false)->
            @scope = scope
            @opts = opts
            @mapCtrl = mapCtrl
            @markerCtrl = markerCtrl
            @isIconVisibleOnClick = isIconVisibleOnClick
            @initialMarkerVisibility = if @markerCtrl? then @markerCtrl.getVisible() else false
            @$log = directives.api.utils.Logger
            @$http = $http
            @$templateCache = $templateCache
            @$compile = $compile
            @createGWin()
            # Open window on click
            @markerCtrl.setClickable(true) if @markerCtrl?

            @handleClick()
            @watchShow()
            @watchCoords()
            @needToManualDestroy = needToManualDestroy
            @$log.info(@)

        createGWin:(createOpts=false) =>
            if !@gWin? and createOpts
                @opts = if @markerCtrl? then  @createWindowOptions(@markerCtrl, @scope, @element.html(), {}) else {}

            if @opts? and @gWin == undefined
                @gWin = new google.maps.InfoWindow(@opts)

                # Set visibility of marker back to what it was before opening the window
                google.maps.event.addListener(@gWin, 'closeclick', =>
                    if @markerCtrl?
                        @markerCtrl.setVisible(@initialMarkerVisibility)
                    @scope.closeClick() if @scope.closeClick?
                )

        watchShow: () =>
            @scope.$watch('show', (newValue, oldValue) =>
                if (newValue != oldValue)
                    if (newValue)
                        @showWindow()
                    else
                        @hideWindow()
                else
                    if @gWin?
                        if (newValue and !@gWin.getMap())
                            # If we're initially showing the marker and it's not yet visible, show it.
                            @showWindow()
            , true)

        watchCoords: ()=>
            @scope.$watch('coords', (newValue, oldValue) =>
                if (newValue != oldValue)
                    @gWin.setPosition(new google.maps.LatLng(newValue.latitude, newValue.longitude))
            , true)

        handleClick: ()=>
            # Show the window and hide the marker on click
            if @markerCtrl?
                google.maps.event.addListener(@markerCtrl, 'click', =>
                    @createGWin(true)
                    pos = @markerCtrl.getPosition()
                    if @gWin?
                        @gWin.setPosition(pos)
                        @gWin.open(@mapCtrl)
                    @markerCtrl.setVisible(@isIconVisibleOnClick)
                )

        showWindow: () =>
            if @scope.templateUrl
                if @gWin
                    @$http.get(@scope.templateUrl, { cache: @$templateCache }).then((content) =>
                        templateScope = @scope.$new()
                        if angular.isDefined(@scope.templateParameter)
                            templateScope.parameter = @scope.templateParameter
                        compiled = @$compile(content.data)(templateScope)
                        @gWin.setContent(compiled.get(0))
                        @gWin.open(@mapCtrl)
                    )
            else
                @gWin.open(@mapCtrl) if @gWin?

        hideWindow: () =>
            @gWin.close() if @gWin?

        destroy: ()=>
            @hideWindow(@gWin)
            if(@scope? and @needToManualDestroy)
                @scope.$destroy()
            delete @gWin
            self = undefined

